#ifndef MMESSAGEDISPLAY_H_
#define MMESSAGEDISPLAY_H_

/**
 * This class should be implemented by an UI or UI-owning class
 * and provides an interface for printing information to the 
 * screen.
 */
class MMessageDisplay
	{
public:
	/**
	 * Print the status message to the screen.
	 * The way it is presented to the user depends on the implementing
	 * class of this interface.
	 * 
	 * @param aText the information text that should be printed.
	 */
	virtual void SetStatusTextL(const TDesC& aText) = 0;
	};

#endif /*MMESSAGEDISPLAY_H_*/
