/*
 ========================================================================
 Name        : SocketsClientAppUi.h
 Copyright   : Symbian Academy, 2007
 Description : Creates default view, logic for handling events,
               owner of softkey/title/...-bar and views.
 =======================================================================
 */
#ifndef SOCKETSCLIENTAPPUI_H
#define SOCKETSCLIENTAPPUI_H

// [[[ begin generated region: do not modify [Generated Includes]
#include <aknviewappui.h>
// ]]] end generated region [Generated Includes]

#include "SocketsEngine.h"
#include "MasteroidsEngine.h"

// [[[ begin generated region: do not modify [Generated Forward Declarations]
class CSocketsClientContainerView;
// ]]] end generated region [Generated Forward Declarations]

/**
 * @class	CSocketsClientAppUi SocketsClientAppUi.h
 * @brief The AppUi class handles application-wide aspects of the user interface, including
 *        view management and the default menu, control pane, and status pane.
 */
class CSocketsClientAppUi : public CAknViewAppUi
	{
public:
	// constructor and destructor
	CSocketsClientAppUi();
	virtual ~CSocketsClientAppUi();
	void ConstructL();

public:
	// from CCoeAppUi
	TKeyResponse HandleKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);

	// from CEikAppUi
	void HandleCommandL( TInt aCommand);
	void HandleResourceChangeL( TInt aType);

	// from CAknAppUi
	void HandleViewDeactivation(const TVwsViewId& aViewIdToBeDeactivated,
			const TVwsViewId& aNewlyActivatedViewId);

private:
	void InitializeContainersL();
	// [[[ begin generated region: do not modify [Generated Methods]
public:
	// ]]] end generated region [Generated Methods]

	// [[[ begin generated region: do not modify [Generated Instance Variables]
private:
	CSocketsClientContainerView* iSocketsClientContainerView;
	// ]]] end generated region [Generated Instance Variables]


	// [[[ begin [User Handlers]
protected:
	// ]]] end [User Handlers]

private:
	/**
	 * The sockets engine handles connecting to the server as well as interaction
	 * with the sockets API.
	 */
	CSocketsEngine* iSocketsEngine; // owned by the AppUi

	/**
	 * The masteroids engine (= game engine) processes key input and sends
	 * messages to the server through the socket engine.
	 */
	CMasteroidsEngine* iMasteroidsEngine; // owned by the AppUi
	};

#endif // SOCKETSCLIENTAPPUI_H			

