/*
 ========================================================================
 Name        : SocketsClientContainerView.h
 Copyright   : Symbian Academy, 2007
 Description : Handles the user interface and interaction for the main view.
 ============================================================================
 */
#ifndef SOCKETSCLIENTCONTAINERVIEW_H
#define SOCKETSCLIENTCONTAINERVIEW_H

// [[[ begin generated region: do not modify [Generated Includes]
#include <aknview.h>
// ]]] end generated region [Generated Includes]

#include "SocketsEngine.h"
#include "MasteroidsEngine.h"
#include "MMessageDisplay.h"

// [[[ begin [Event Handler Includes]
// ]]] end [Event Handler Includes]

// [[[ begin generated region: do not modify [Generated Forward Declarations]
class CSocketsClientContainer;
// ]]] end generated region [Generated Forward Declarations]

// [[[ begin generated region: do not modify [Generated Constants]
// ]]] end generated region [Generated Constants]

/**
 * Avkon view class for SocketsClientContainerView. It is register with the view server
 * by the AppUi. It owns the container control.
 * @class	CSocketsClientContainerView SocketsClientContainerView.h
 */
class CSocketsClientContainerView : public CAknView, public MMessageDisplay
	{
public:
	// constructors and destructor
	CSocketsClientContainerView();
	static CSocketsClientContainerView* NewL();
	static CSocketsClientContainerView* NewLC();
	void ConstructL();
	virtual ~CSocketsClientContainerView();

public:
	// from base class CAknView
	TUid Id() const;
	void HandleCommandL( TInt aCommand);

protected:
	// from base class CAknView
	void DoActivateL(const TVwsViewId& aPrevViewId, TUid aCustomMessageId,
			const TDesC8& aCustomMessage);
	void DoDeactivate();
	void HandleStatusPaneSizeChange();

private:
	void SetupStatusPaneL();
	void CleanupStatusPane();
	// [[[ begin generated region: do not modify [Generated Methods]
public: 
	// ]]] end generated region [Generated Methods]
	void SetEngines(CMasteroidsEngine* aMasteroidsEngine,
			CSocketsEngine* aSocketsEngine);
	void SetStatusTextL(const TDesC& aText);
	// [[[ begin [Overridden Methods]
protected:
	// ]]] end [Overridden Methods]

	void DynInitMenuPaneL(TInt aResourceId, CEikMenuPane *aMenuPane);

	// [[[ begin [User Handlers]
protected:
	TBool HandleConnectMenuItemSelectedL( TInt aCommand);
	TBool HandleDisconnectMenuItemSelectedL( TInt aCommand);
	TBool HandleLoginMenuItemSelectedL( TInt aCommand);
	// ]]] end [User Handlers]

	// [[[ begin generated region: do not modify [Generated Instance Variables]
private: 
	CSocketsClientContainer* iSocketsClientContainer;
	// ]]] end generated region [Generated Instance Variables]

	CSocketsEngine* iSocketsEngine; // owned by the AppUi
	CMasteroidsEngine* iMasteroidsEngine; // owned by the AppUi
	};

#endif // SOCKETSCLIENTCONTAINERVIEW_H			

