/*
========================================================================
 Name        : SocketsClientAppUi.cpp
 Copyright   : Symbian Academy, 2007
 Description : Creates default view, logic for handling events,
               owner of softkey/title/...-bar and views.
========================================================================
*/
// [[[ begin generated region: do not modify [Generated System Includes]
#include <eikmenub.h>
#include <akncontext.h>
#include <akntitle.h>
#include <SocketsClient.rsg>
// ]]] end generated region [Generated System Includes]

// [[[ begin generated region: do not modify [Generated User Includes]
#include "SocketsClientAppUi.h"
#include "SocketsClient.hrh"
#include "SocketsClientContainerView.h"
// ]]] end generated region [Generated User Includes]

// [[[ begin generated region: do not modify [Generated Constants]
// ]]] end generated region [Generated Constants]

/**
 * Construct the CSocketsClientAppUi instance
 */ 
CSocketsClientAppUi::CSocketsClientAppUi()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]
	
	}

/** 
 * The appui's destructor removes the container from the control
 * stack and destroys it.
 */
CSocketsClientAppUi::~CSocketsClientAppUi()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]

	delete iMasteroidsEngine;
	delete iSocketsEngine;
	}

// [[[ begin generated function: do not modify
void CSocketsClientAppUi::InitializeContainersL()
	{
	iSocketsClientContainerView = CSocketsClientContainerView::NewL();
	AddViewL( iSocketsClientContainerView );
	SetDefaultViewL( *iSocketsClientContainerView );
	}
// ]]] end generated function

/**
 * Handle a command for this appui (override)
 * @param aCommand command id to be handled
 */
void CSocketsClientAppUi::HandleCommandL( TInt aCommand )
	{
	// [[[ begin generated region: do not modify [Generated Code]
	TBool commandHandled = EFalse;
	switch ( aCommand )
		{ // code to dispatch to the AppUi's menu and CBA commands is generated here
		default:
			break;
		}
	
		
	if ( !commandHandled ) 
		{
		if ( aCommand == EAknSoftkeyExit || aCommand == EEikCmdExit )
			{
			Exit();
			}
		}
	// ]]] end generated region [Generated Code]
	
	}

/** 
 * Override of the HandleResourceChangeL virtual function
 */
void CSocketsClientAppUi::HandleResourceChangeL( TInt aType )
	{
	CAknViewAppUi::HandleResourceChangeL( aType );
	// [[[ begin generated region: do not modify [Generated Code]
	// ]]] end generated region [Generated Code]
	
	}
				
/** 
 * Override of the HandleKeyEventL virtual function
 * @return EKeyWasConsumed if event was handled, EKeyWasNotConsumed if not
 * @param aKeyEvent 
 * @param aType 
 */
TKeyResponse CSocketsClientAppUi::HandleKeyEventL(
		const TKeyEvent& aKeyEvent,
		TEventCode aType )
	{
	// The inherited HandleKeyEventL is private and cannot be called
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]
	
	return iMasteroidsEngine->ProcessKeyEventL(aKeyEvent, aType);
	}

/** 
 * Override of the HandleViewDeactivation virtual function
 *
 * @param aViewIdToBeDeactivated 
 * @param aNewlyActivatedViewId 
 */
void CSocketsClientAppUi::HandleViewDeactivation( 
		const TVwsViewId& aViewIdToBeDeactivated, 
		const TVwsViewId& aNewlyActivatedViewId )
	{
	CAknViewAppUi::HandleViewDeactivation( 
			aViewIdToBeDeactivated, 
			aNewlyActivatedViewId );
	// [[[ begin generated region: do not modify [Generated Contents]
	// ]]] end generated region [Generated Contents]
	
	}

/**
 * @brief Completes the second phase of Symbian object construction. 
 * Put initialization code that could leave here. 
 */ 
void CSocketsClientAppUi::ConstructL()
	{
	iMasteroidsEngine = CMasteroidsEngine::NewL();
	iSocketsEngine = CSocketsEngine::NewL(iMasteroidsEngine);
	
	// [[[ begin generated region: do not modify [Generated Contents]
	BaseConstructL( EAknEnableSkin );
	InitializeContainersL();
	// ]]] end generated region [Generated Contents]

	// Distribute the references so that the engines can communicate with each other
	// The masteroids engine has to send messages through the sockets engine
	iMasteroidsEngine->SetSocketsEngine(iSocketsEngine);
	// The view has to send key events to the masteroids engine and connect / disconnect
	// events to the sockets engine
	iSocketsClientContainerView->SetEngines(iMasteroidsEngine, iSocketsEngine);
	// The masteroids engine has to be able to display status messages on the screen
	iMasteroidsEngine->SetMessageDisplay(iSocketsClientContainerView);
	}

